// MC600DemoDlg.cpp : implementation file
//

#include "stdafx.h"
#include "MC600Demo.h"
#include "MC600DemoDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About
int nAxis;
class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CMC600DemoDlg dialog

CMC600DemoDlg::CMC600DemoDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CMC600DemoDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CMC600DemoDlg)
	m_editStepAngle = 0.0f;
	m_editStagePitch = 0.0f;
	m_editMicroStep = 0.0f;
	m_editDriverRate = 0.0f;
	m_editRadius = 0.0f;
	m_editDistance = 0.0f;
	m_nRein = 0.0f;
	m_useusb = 0;
	m_usbstr = _T("");
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CMC600DemoDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CMC600DemoDlg)
	DDX_Control(pDX, IDC_COMBO1, m_cbo1);
	DDX_Control(pDX, IDC_ZOLIXMC6002CTRL1, m_ctrl);
	DDX_Text(pDX, IDC_EDIT1, m_editStepAngle);
	DDX_Text(pDX, IDC_EDIT4, m_editStagePitch);
	DDX_Text(pDX, IDC_EDIT2, m_editMicroStep);
	DDX_Text(pDX, IDC_EDIT3, m_editDriverRate);
	DDX_Text(pDX, IDC_EDIT5, m_editRadius);
	DDX_Text(pDX, IDC_EDIT7, m_editDistance);
	DDX_Text(pDX, IDC_EDIT6, m_nRein);
	DDX_Radio(pDX, IDC_RADIO5, m_useusb);
	DDX_CBString(pDX, IDC_COMBO1, m_usbstr);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CMC600DemoDlg, CDialog)
	//{{AFX_MSG_MAP(CMC600DemoDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_BUTTON1, OnButton1)
	ON_BN_CLICKED(IDC_BUTTON4, OnButton4)
	ON_BN_CLICKED(IDC_RADIO1, OnRadio1)
	ON_BN_CLICKED(IDC_RADIO2, OnRadio2)
	ON_BN_CLICKED(IDC_RADIO3, OnRadio3)
	ON_BN_CLICKED(IDC_RADIO4, OnRadio4)
	ON_BN_CLICKED(IDC_BUTTON8, OnButton8)
	ON_BN_CLICKED(IDC_BUTTON6, OnButton6)
	ON_BN_CLICKED(IDC_BUTTON7, OnButton7)
	ON_BN_CLICKED(IDC_RADIO5, OnRadio5)
	ON_BN_CLICKED(IDC_RADIO6, OnRadio6)
	ON_BN_CLICKED(IDC_BUTTON3, OnStop)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CMC600DemoDlg message handlers

BOOL CMC600DemoDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	// TODO: Add extra initialization here
	UpdatePortList(m_useusb);
	((CButton*)GetDlgItem(IDC_RADIO1))->SetCheck(1);
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CMC600DemoDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CMC600DemoDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CMC600DemoDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CMC600DemoDlg::OnButton1() 
{
	// TODO: Add your control notification handler code here
	UpdateData();
	int a;
	switch(m_useusb) 
	{
	case 0:
		a=m_cbo1.GetCurSel()+1;
		m_ctrl.SetComPort(a);
		break;
	case 1:
		m_ctrl.SetUSBSerials(m_usbstr);
		break;
	}
	if(m_ctrl.Connect())
	{
		MessageBox("ӳɹ");
		OnRadio1();
	}
	else
	{
		MessageBox("ʧ");
	}
	
}
void CMC600DemoDlg::OnButton5() 
{
	// TODO: Add your control notification handler code here
	m_ctrl.SetchroMode(true);
	BOOL res=m_ctrl.GoPosition(2,1,1,1,180);
	int s=33;
	
}
void CMC600DemoDlg::OnButton4() 
{
	// TODO: Add your control notification handler code here
	m_editStepAngle=m_ctrl.GetStepAngle(nAxis);//1.80000
	m_editStagePitch=m_ctrl.GetPitch(nAxis);//4.00000
	m_editMicroStep=m_ctrl.GetMicroStep(nAxis);//8
	m_editDriverRate=m_ctrl.GetDriveRat(nAxis);//180
	m_editRadius=m_ctrl.Getradius(nAxis);//50
	m_editDistance=m_ctrl.Getdistance(nAxis);//1000.00
	UpdateData(0);
}

void CMC600DemoDlg::OnRadio1() 
{
	// TODO: Add your control notification handler code here
	nAxis=0;
	OnButton4();
	
}

void CMC600DemoDlg::OnRadio2() 
{
	// TODO: Add your control notification handler code here
    nAxis=1;
    OnButton4();
}

void CMC600DemoDlg::OnRadio3() 
{
	// TODO: Add your control notification handler code here
	nAxis=2;
	OnButton4();
	
}

void CMC600DemoDlg::OnRadio4() 
{
	// TODO: Add your control notification handler code here
	nAxis=3;
	OnButton4();
	
}

void CMC600DemoDlg::OnButton8() 
{
	// TODO: Add your control notification handler code here
	m_ctrl.GoHome(nAxis);
	
}

void CMC600DemoDlg::OnButton6() 
{
	// TODO: Add your control notification handler code here
	short workstate=1,state=1,dir=1;
	float x;
	UpdateData(1);
	x=m_nRein;
	workstate=m_ctrl.Getworkstate(nAxis);
	m_ctrl.GoPosition(nAxis,workstate,1,dir,x);
	
}

void CMC600DemoDlg::OnButton7() 
{
	// TODO: Add your control notification handler code here
	short workstate=1,state=1,dir=0;
	float x;
	UpdateData(1);
	x=m_nRein;
	workstate=m_ctrl.Getworkstate(nAxis);
	m_ctrl.GoPosition(nAxis,workstate,state,dir,x);

	
}
void CMC600DemoDlg::UpdatePortList(short nPortType)
{
	long i;
	CString str;

	m_cbo1.ResetContent();
	
	switch(nPortType)
	{
	case 0:
		m_ctrl.SetUsbmode(FALSE);
		for(i=0;i<50;i++)
		{
			str.Format("COM%d",i+1);
			m_cbo1.AddString(str);
		}		
		break;
	case 1:
		m_ctrl.SetUsbmode(TRUE);
		long nCount;
		nCount=m_ctrl.SearchZolixUSBDevice();
		for(i=0;i<nCount;i++)
		{
			str=m_ctrl.GetZolixUSBSerial(i);
			m_cbo1.AddString(str);
		}
		break;
	}
	
}

void CMC600DemoDlg::OnRadio5() 
{
	// TODO: Add your control notification handler code here
	UpdateData();
	UpdatePortList(m_useusb);
	((CButton*)GetDlgItem(IDC_RADIO1))->SetCheck(1);
}

void CMC600DemoDlg::OnRadio6() 
{
	// TODO: Add your control notification handler code here
	UpdateData();
	UpdatePortList(m_useusb);
	((CButton*)GetDlgItem(IDC_RADIO1))->SetCheck(1);
}

void CMC600DemoDlg::OnStop() 
{
	// TODO: Add your control notification handler code here
	m_ctrl.Stop(nAxis);
}
